using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZXDT.DBUtility;
using System.Data;
using System.Data.SqlClient;

namespace ZXDT.CallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_ModuleFunctionsOpt
    /// </summary>
    public partial class T_Sys_ModuleFunctionsOpt
    {
        public T_Sys_ModuleFunctionsOpt()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_ModuleFunctionsOpt");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_Id", SqlDbType.Int,4)
			};
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(ZXDT.CallCenter.Model.T_Sys_ModuleFunctionsOpt model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_ModuleFunctionsOpt(");
            strSql.Append("F_FunctionId,F_FunctionCode,F_OptName,F_OptCode,F_Remark,F_ControlId,F_ControlCode)");
            strSql.Append(" values (");
            strSql.Append("@F_FunctionId,@F_FunctionCode,@F_OptName,@F_OptCode,@F_Remark,@F_ControlId,@F_ControlCode)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
					new SqlParameter("@F_FunctionId", SqlDbType.Int,4),
					new SqlParameter("@F_FunctionCode", SqlDbType.VarChar,50),
					new SqlParameter("@F_OptName", SqlDbType.VarChar,50),
					new SqlParameter("@F_OptCode", SqlDbType.VarChar,50),
					new SqlParameter("@F_Remark", SqlDbType.VarChar,200),
					new SqlParameter("@F_ControlId", SqlDbType.Int,4),
					new SqlParameter("@F_ControlCode", SqlDbType.VarChar,50)};
            parameters[0].Value = model.F_FunctionId;
            parameters[1].Value = model.F_FunctionCode;
            parameters[2].Value = model.F_OptName;
            parameters[3].Value = model.F_OptCode;
            parameters[4].Value = model.F_Remark;
            parameters[5].Value = model.F_ControlId;
            parameters[6].Value = model.F_ControlCode;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_Sys_ModuleFunctionsOpt model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_ModuleFunctionsOpt set ");
            strSql.Append("F_FunctionId=@F_FunctionId,");
            strSql.Append("F_FunctionCode=@F_FunctionCode,");
            strSql.Append("F_OptName=@F_OptName,");
            strSql.Append("F_OptCode=@F_OptCode,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_ControlId=@F_ControlId,");
            strSql.Append("F_ControlCode=@F_ControlCode");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_FunctionId", SqlDbType.Int,4),
					new SqlParameter("@F_FunctionCode", SqlDbType.VarChar,50),
					new SqlParameter("@F_OptName", SqlDbType.VarChar,50),
					new SqlParameter("@F_OptCode", SqlDbType.VarChar,50),
					new SqlParameter("@F_Remark", SqlDbType.VarChar,200),
					new SqlParameter("@F_ControlId", SqlDbType.Int,4),
					new SqlParameter("@F_ControlCode", SqlDbType.VarChar,50),
					new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_FunctionId;
            parameters[1].Value = model.F_FunctionCode;
            parameters[2].Value = model.F_OptName;
            parameters[3].Value = model.F_OptCode;
            parameters[4].Value = model.F_Remark;
            parameters[5].Value = model.F_ControlId;
            parameters[6].Value = model.F_ControlCode;
            parameters[7].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_ModuleFunctionsOpt ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_Id", SqlDbType.Int,4)
			};
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_ModuleFunctionsOpt ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Sys_ModuleFunctionsOpt GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_FunctionId,F_FunctionCode,F_OptName,F_OptCode,F_Remark,F_ControlId,F_ControlCode from T_Sys_ModuleFunctionsOpt ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_Id", SqlDbType.Int,4)
			};
            parameters[0].Value = F_Id;

            ZXDT.CallCenter.Model.T_Sys_ModuleFunctionsOpt model = new ZXDT.CallCenter.Model.T_Sys_ModuleFunctionsOpt();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Sys_ModuleFunctionsOpt DataRowToModel(DataRow row)
        {
            ZXDT.CallCenter.Model.T_Sys_ModuleFunctionsOpt model = new ZXDT.CallCenter.Model.T_Sys_ModuleFunctionsOpt();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_FunctionId"] != null && row["F_FunctionId"].ToString() != "")
                {
                    model.F_FunctionId = int.Parse(row["F_FunctionId"].ToString());
                }
                if (row["F_FunctionCode"] != null)
                {
                    model.F_FunctionCode = row["F_FunctionCode"].ToString();
                }
                if (row["F_OptName"] != null)
                {
                    model.F_OptName = row["F_OptName"].ToString();
                }
                if (row["F_OptCode"] != null)
                {
                    model.F_OptCode = row["F_OptCode"].ToString();
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_ControlId"] != null && row["F_ControlId"].ToString() != "")
                {
                    model.F_ControlId = int.Parse(row["F_ControlId"].ToString());
                }
                if (row["F_ControlCode"] != null)
                {
                    model.F_ControlCode = row["F_ControlCode"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_FunctionId,F_FunctionCode,F_OptName,F_OptCode,F_Remark,F_ControlId,F_ControlCode ");
            strSql.Append(" FROM T_Sys_ModuleFunctionsOpt ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_FunctionId,F_FunctionCode,F_OptName,F_OptCode,F_Remark,F_ControlId,F_ControlCode ");
            strSql.Append(" FROM T_Sys_ModuleFunctionsOpt ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_ModuleFunctionsOpt ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_ModuleFunctionsOpt T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }


        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
